#ifndef ALIST_H
#define ALIST_H

#include "list.h"
#include "intlist.h"

struct alist {
	struct intlist * keys;
	struct list * values;
};

/* creation and destruction operations */

struct alist * alistCreate(void (* alistFreeElement)(void *),void * (alistCopyElement)(void *),void (* alistDisplayElement)(void *));
void alistFree(struct alist * l);

struct alist * alistCopy(struct alist * l);

/* access operations */

int alistLength(struct alist * l);

int alistSize(struct alist * l);

int alistIsEmpty(struct alist * l);

void * alistGet(struct alist * l,int key);

int alistContain(struct alist * l,int key);
int alistNumber(struct alist * l,int key);

/* update operations */

void alistRemoveAll(struct alist * l,int key);

void alistRemoveParticular(struct alist * l,int key,void * value,int (* compare)(void *,void *));

void alistRemoveParticularStandard(struct alist * l,int key,void * value);

void alistAdd(struct alist * l,int key,void * value);

/* sorting and searching */

void alistSort(struct alist * l);

void alistDisplay(struct alist * l);

#endif
