#ifndef BANDWIDTH_H
#define BANDWIDTH_H

#include "ugraph.h"
#include "utree.h"

struct bandwidth {
	struct ugraph * graph;
	int * capacity;
	int * residual;
};

struct bandwidth * bandwidthCreate(struct ugraph * graph);

void bandwidthFree(struct bandwidth * b);

void bandwidthDisplay(struct bandwidth * b);

int bandwidthCheckGroup(struct bandwidth * b,struct intlist * group,struct utree * tree,int groupRequirement);
int bandwidthAddGroup(struct bandwidth * b,struct intlist * group,struct utree * tree,int groupRequirement);
int bandwidthRemoveGroup(struct bandwidth * b,struct intlist * group,struct utree * tree,int groupRequirement);
struct bandwidth * bandwidthCopy(struct bandwidth * b);
#endif
