#include "intstack.h"
#include "qerror.h"

/* creates an empty intstack */
struct intstack * intstackCreate() {
	struct intstack * s;
	QERROR_MALLOC(s,1,struct intstack);
	s->l = intlistCreate();
	return s;
}

/* frees "s" */
void intstackFree(struct intstack * s) {
	if (s==NULL) {
		QERROR("parameters");
	}
	intlistFree(s->l);
	free(s);
}

/* copies "s" into a new intstack */
struct intstack * intstackCopy(struct intstack * s) {
	struct intstack * copy;
	if (s==NULL) {
		QERROR("parameters");
	}
	QERROR_MALLOC(copy,1,struct intstack);
	copy->l = intlistCopy(s->l);
	return copy;
}

/* returns the top of "s" */
int intstackTop(struct intstack * s) {
	if (s==NULL) {
		QERROR("parameters");
	}
	return intlistFront(s->l);
}

/* pushes "value" to "s" */
void intstackPush(struct intstack * s,int value) {
	if (s==NULL) {
		QERROR("parameters");
	}
	intlistPush(s->l,value);
}

/* popes "s" */
int intstackPop(struct intstack * s) {
	if (s==NULL) {
		QERROR("parameters");
	}
	return intlistPop(s->l);
}

/* returns the size of "s" */
int intstackSize(struct intstack * s) {
	if (s==NULL) {
		QERROR("parameters");
	}
	return intlistSize(s->l);
}

/* checks if "s" is empty */
int intstackIsEmpty(struct intstack * s) {
	if (s==NULL) {
		QERROR("parameters");
	}
	return intlistIsEmpty(s->l);
}

/* clears "s" */
void intstackClear(struct intstack * s) {
	if (s==NULL) {
		QERROR("parameters");
	}
	intlistClear(s->l);
}

/* displays "s" */
void intstackDisplay(struct intstack * s) {
	if (s==NULL) {
		QERROR("parameters");
	}
	intlistDisplay(s->l);
}
