#include "random.h"
#include "qerror.h"
#include <stdio.h>
#include <stdlib.h>
#include "intlist.h"

/* returns a random integer in [0,"bound"[ */
int randomGet(int bound) {
	if (bound<=0) {
		QERROR("parameters");
	}
	//return (int)(bound*rand()/(RAND_MAX+1.0));
	return rand()%bound;
}

/* inits the random generator with "seed" */
void randomInit(unsigned int seed) {
	srand(seed);
}

/* returns a random intlist of "number" integers in [0,"bound"[, without having two times the same integer */
struct intlist * randomList(int number,int bound) {
	struct intlist * l;
	int i;
	int r;
	if ((number<0) || (bound<0) || (number>bound)) {
		QERROR("parameters");
	}
	l = intlistCreate();
	for (i=0;i<number;i++) {
		do {
			r = randomGet(bound);
			//printf("ajout de %d ?\n",r);
		} while (intlistContain(l,r));
		intlistPush(l,r);
		//printf("ajout de %d\n",r);
	}
	return l;
}
