#ifndef STACK_H
#define STACK_H

#include "list.h"

struct stack {
	struct list * l;
};

struct stack * stackCreate(void (* stackFreeElement)(void *),void * (* stackCopyElement)(void *),void (* stackDisplayElement)(void *));
void stackFree(struct stack * s);

struct stack * stackCopy(struct stack * s);

void * stackTop(struct stack * s);
void stackPush(struct stack * s,void * element);
void * stackPop(struct stack * s);

int stackSize(struct stack * s);
int stackIsEmpty(struct stack * s);

void stackClear(struct stack * s);

void stackDisplay(struct stack * s);

#endif
